SyntheticRepository (Apache Commons BCEL 6.4.1 API)

org.apache.bcel.util

## Class SyntheticRepository

- java.lang.Object
- - org.apache.bcel.util.MemorySensitiveClassPathRepository
  - - org.apache.bcel.util.SyntheticRepository

- All Implemented Interfaces:
    Repository

      public class SyntheticRepository
      extends MemorySensitiveClassPathRepository

  This repository is used in situations where a Class is created outside the realm of a ClassLoader. Classes are loaded from the file systems using the paths specified in the given class path. By default, this is the value returned by ClassPath.getClassPath().

  This repository uses a factory design, allowing it to maintain a collection of different classpaths, and as such It is designed to be used as a singleton per classpath.

  See Also:
    `Repository`

- - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `ClassPath` | `getClassPath()` Gets the ClassPath associated with this Repository
    `static SyntheticRepository` | `getInstance()`
    `static SyntheticRepository` | `getInstance(ClassPath classPath)`
    `JavaClass` | `loadClass(Class<?> clazz)` Finds the JavaClass object for a runtime Class object.
    `JavaClass` | `loadClass(String className)` Finds a JavaClass object by name.

    - ### Methods inherited from class org.apache.bcel.util.MemorySensitiveClassPathRepository

      `clear, findClass, removeClass, storeClass`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Method Detail

    - #### getInstance

          public static SyntheticRepository getInstance()

    - #### getInstance

          public static SyntheticRepository getInstance(ClassPath classPath)

    - #### loadClass

          public JavaClass loadClass(String className)
                              throws ClassNotFoundException

      Finds a JavaClass object by name. If it is already in this Repository, the Repository version is returned. Otherwise, the Repository's classpath is searched for the class (and it is added to the Repository if found).
      Specified by:
        `loadClass` in interface `Repository`
      Parameters:
        `className` - the name of the class
      Returns:
        the JavaClass object
      Throws:
        `ClassNotFoundException` - if the class is not in the Repository, and could not be found on the classpath

    - #### loadClass

          public JavaClass loadClass(Class<?> clazz)
                              throws ClassNotFoundException

      Finds the JavaClass object for a runtime Class object. If a class with the same name is already in this Repository, the Repository version is returned. Otherwise, getResourceAsStream() is called on the Class object to find the class's representation. If the representation is found, it is added to the Repository.
      Specified by:
        `loadClass` in interface `Repository`
      Parameters:
        `clazz` - the runtime Class object
      Returns:
        JavaClass object for given runtime class
      Throws:
        `ClassNotFoundException` - if the class is not in the Repository, and its representation could not be found
      See Also:
        `Class`

    - #### getClassPath

          public ClassPath getClassPath()

      Description copied from interface: `Repository`
      Gets the ClassPath associated with this Repository
      Specified by:
        `getClassPath` in interface `Repository`

Copyright © 2004–2019 The Apache Software Foundation. All rights reserved.